<?php

namespace App\Models\Customer;

use App\Entities\Customer\ServiceEntity;

class ServiceModel extends CustomerModel
{
    const TABLE = "serviceinfo";
    const PK = "uid";
    const TITLE = "code";
    protected $table            = self::TABLE;
    protected $primaryKey       = self::PK;
    protected $returnType       = ServiceEntity::class;
    protected $allowedFields = [
        "clientinfo_uid",
        "ownerinfo_uid",
        "user_uid",
        "switchinfo_uid",
        "codeinfo_uid",
        "code",
        "type",
        "location",
        "raid",
        "billing_at",
        "start_at",
        "status",
        "updated_at"
    ];
    public function __construct()
    {
        parent::__construct();
    }
    public function getFormFieldRule(string $action, string $field): string
    {
        if (is_array($field)) {
            throw new \Exception(__FUNCTION__ . "=> field가 array 입니다.\n" . var_export($field, true));
        }
        switch ($field) {
            case "clientinfo_uid":
            case "ownerinfo_uid":
            case "user_uid":
            case "switchinfo_uid":
            case "codeinfo_uid":
                $rule  = "required|numeric";
                break;
            case "code":
                $rule  = "if_exist|trim|string";
                break;
            case "type":
            case "location":
            case "status":
                $rule = "required|trim|string";
                break;
            case "billing_at":
            case "start_at":
                $rule = "required|valid_date";
                break;
            case "raid":
                $rule = "if_exist|trim|string";
                break;
            default:
                $rule = parent::getFormFieldRule($action, $field);
                break;
        }
        return $rule;
    }
    //Create용
    protected function create_process(array $formDatas): ServiceEntity
    {
        $entity = parent::create_process($formDatas);
        // 생성 후, 추가 작업이 필요할 경우 여기에 작성
        $formDatas = ['code' => SITE_PREFIX['Service'] . time()];
        return $this->modify($entity, $formDatas);
    }
}
